﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private ws As WebSocket 'ignore
	' will hold our page information
	Public page As ABMPage
	' page theme
	Private theme As ABMTheme
	' to access the constants
	Private ABM As ABMaterial 'ignore
	' name of the page, must be the same as the class name (case sensitive!)
	Public Name As String = "ABMPageTemplate"  '<-------------------------------------------------------- IMPORTANT
	' will hold the unique browsers window id
	Private ABMPageId As String = ""
	
	' your own variables
	Private ToastId As Int 'ignore
	' our multi component	
	Private MultiBox As ABMMulti
	' holds our selected items
	Private SelectedItems As String
	' just a variable to hold if the data was already loaded
	Private NotYetLoaded As Boolean = True
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	' build the local structure IMPORTANT!
	BuildPage
End Sub

#Region Always needed, no need to change anything at them
Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	Log("Connected")		
	ws = WebSocket1	
	ABMPageId = ABM.GetPageID(page, Name,ws)
	
	Main.Server.Connected(Me, ws, page, ABMPageId)
	
	Log(ABMPageId)
End Sub

Private Sub WebSocket_Disconnected
	Log("Disconnected")
	Main.Server.Disconnected(ws)	
End Sub

Sub Page_ParseEvent(Params As Map)
	Main.Server.Page_ParseEvent(Me, page, ABMPageId, Params)
End Sub
#end region

' MUST be in here
public Sub BuildTheme()
	' start with the base theme defined in ABMShared
	theme.Initialize("pagetheme")
	theme.AddABMTheme(Main.MyTheme)

	' add page specific theme elements	
End Sub

' MUST be in here
public Sub BuildPage()
	' initialize the theme
	BuildTheme
	
	' initialize this page using our theme
	page.InitializeWithTheme(Name, "/ws/" & Main.Server.AppName & "/" & Name, False, Main.Server.SessionMaxInactiveIntervalSeconds, theme)
	page.ShowLoader=True
	page.PageHTMLName = "index.html"
	page.PageTitle = "Demo"
	page.PageDescription = "ABMBANano Demo"
	page.PageSiteMapFrequency = ABM.SITEMAP_FREQ_YEARLY
		
	page.ShowConnectedIndicator = True
	
	page.AddExtraJavaScriptFile("bananocore.js")
	page.AddExtraJavaScriptFile("Multi/multi.js")
	page.AddExtraCSSFile("Multi/multi.css")
	' unless you use a specific other place where your Static Files are, this will always be "www"
	Multi.UnzipAssets("www")
				
	' adding a navigation bar
	Main.BuildNavigationBar(page, "Title","../images/logo.png", "", "", "")
			
	' create the page grid, here we create 5 rows, each with one cell of 12 columns wide.
	page.AddRowsM(5,True,0,0, "").AddCells12MP(1,0,0,0,0,"")
	page.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
		
End Sub

' MUST be in here
public Sub ConnectPage()
	' connecting the navigation bar
	Main.ConnectNavigationBar(page)

	' ----------- do your stuff like adding components to your grid, created in BuildPage
	page.AddModalSheetTemplate(BuildForModalMultiSelect("Articles"))
	
	Dim button As ABMButton
	button.InitializeFlat(page, "button", "", "", "Open", "")
	page.Cell(2,1).AddComponent(button)	
	
	Dim Result As ABMLabel
	Result.Initialize(page, "Result", "", ABM.SIZE_H6, False, "")
	page.Cell(3,1).AddComponent(Result)
	' -----------
	
	' refresh the page
	page.Refresh	
	' Tell the browser we finished loading
	page.FinishedLoading
	' restoring the navigation bar position
	page.RestoreNavigationBarPosition
	
	' initialize our multi box
	MultiBox.Initialize(ws,"modalmultiselectlayout-content-r1c1", "MultiBox", False)
End Sub

Sub button_Clicked(Target As String)
	MultiBox.empty(ws)
	
	Dim TemplateParams As List
	TemplateParams.Initialize
	TemplateParams.Add("id")
	TemplateParams.Add("t1")
	TemplateParams.Add("t2")
	TemplateParams.Add("im")
	
	If NotYetLoaded Then
		MultiBox.LoadAllItems(ws,GetFakeData, "id")
	End If	
	NotYetLoaded = False
	
	If SelectedItems <> "" Then
		MultiBox.SelectItems(ws,SelectedItems)
	Else	
		' send an empty map
		MultiBox.SelectItems(ws,"{}")
	End If
	
	MultiBox.SetTemplate(ws,$"<div class="col s12 m6 l3">
	<div id="ms{id}" class="mi-box mi-box-{eventName} {selected}">
		<div class="row mi-row mi-row-no-margin-bottom">
			<div class="mi-col-left">
				<img src="../images/{im}.jpg" width="48" height="48" class="mi-img">
			</div>
			<div class="mi-col-right">
				<div class="row mi-row mi-row-no-margin-right">
					<div class="col s12 m12 l12 mi-col mi-col-bold">
						{t1}
					</div>			
				</div>
				<div class="row mi-row mi-row-no-margin-right">
					<div class="col s12 m12 l12 mi-col mi-col-smaller">
						{t2}
					</div>			
				</div>
			</div>
		</div>		
	</div>	
	</div>"$, TemplateParams)
	
	MultiBox.Build(ws,4)
		
	page.ForceResizeCells(250, True)
	page.ShowModalSheet("ModalMultiSelectLayout")
End Sub

' clicked on the navigation bar
Sub Page_NavigationbarClicked(Action As String, Value As String)
	' saving the navigation bar position
	page.SaveNavigationBarPosition
	If Action = "LogOff" Then
		Main.LogOff(page)
		Return
	End If

	Main.Server.NavigateToPage(ws, ABMPageId, Value)
End Sub

' a modal sheet to hold our multi select
public Sub BuildForModalMultiSelect(title As String) As ABMModalSheet
	Dim Modal As ABMModalSheet
	Modal.Initialize(page, "ModalMultiSelectLayout", False, ABM.MODALSHEET_TYPE_NORMAL, "")
	Modal.IsDismissible = True
	Modal.Size = ABM.MODALSHEET_SIZE_FULL
	
	'Modal.NeverShowVerticalScrollBar = True
	
	' Build the header grid
	Modal.header.AddRowsM(1,True,0,0, "").AddCellsOS(1,0,0,0,6,6,9,"center").AddCellsOS(1,0,0,0,6,6,3,"right")
	Modal.header.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
		
	Modal.Header.Row(1).PaddingTop = "10px"
	Modal.Header.Row(1).PaddingBottom = "10px"

	' add the title
	Dim lblTitle As ABMLabel
	lblTitle.Initialize(page, "lblTitle", title, ABM.SIZE_H5, False, "")
	lblTitle.SetExtraStyle("margin-top: 6px;margin-bottom: 0px;color: white !important;font-weight: 600")
		
	Modal.header.Cell(1,1).AddComponent(lblTitle)
	
	' create the buttons for the header	
	Dim Cancel As ABMButton
	Cancel.InitializeFlat(page, "SelectCancel", "fa fa-times", ABM.ICONALIGN_CENTER, "", "transparent")
	Modal.header.Cell(1,2).AddComponent(Cancel)
	
	Dim Done As ABMButton
	Done.InitializeFlat(page, "SelectDone", "fa fa-check", ABM.ICONALIGN_CENTER, "", "transparent")
	Modal.header.Cell(1,2).AddComponent(Done)
	
	' Build the content grid that will hold our BANano Multi Select items
	Modal.Content.AddRowsM(1, True,0,0, "").AddCells12(1, "")
	Modal.Content.BuildGrid  'IMPORTANT once you loaded the complete grid AND before you start adding components
	
	' make the cell a fixed height from the bottom
	Modal.Content.Cell(1,1).SetFixedHeightFromBottom(40, False)
	
	Return Modal	
End Sub

Sub SelectDone_Clicked(Target As String)
	page.CloseModalSheet("ModalMultiSelectLayout")
	Dim Result As ABMLabel
	Result = page.Component("result")
	SelectedItems = MultiBox.GetAllSelected(ws)
	Result.Text = SelectedItems
	Result.Refresh
End Sub

Sub SelectCancel_Clicked(Target As String)
	page.CloseModalSheet("ModalMultiSelectLayout")
End Sub

' build some fake data
Public Sub GetFakeData() As String
	Dim Ret As StringBuilder
	Ret.Initialize
	Ret.Append("[")
	For i = 1 To 95
		If (i>1) Then
			Ret.Append(",")
		End If
		Ret.Append("{")
		Ret.Append($""id":${i},"$)
		Ret.Append($""t1":"${ABM.Util.randomWord}","$)
		Ret.Append($""t2":"${ABM.Util.randomWord}","$)
		Ret.Append($""im":"${i}""$)
		Ret.Append("}")
	Next
	Ret.Append("]")
	Return Ret.ToString
End Sub